uses SysUtils, KambiUtils, KambiClassUtils, VRMLNodes, Object3dAsVRML,
  VRMLFlatScene, VectorMath;

type
  TTriangleProcessor = class
    procedure TriangleProc(const Tri: TTriangle3Single;
      State: TVRMLGraphTraverseState; ShapeNode: TNodeGeneralShape;
      const MatNum, FaceCoordIndexBegin, FaceCoordIndexEnd: Integer);
  end;

procedure TTriangleProcessor.TriangleProc(const Tri: TTriangle3Single;
  State: TVRMLGraphTraverseState; ShapeNode: TNodeGeneralShape;
  const MatNum, FaceCoordIndexBegin, FaceCoordIndexEnd: Integer);
var
  Col: TVector3Single;

  procedure OutputOdcinek(const P1, P2: TVector3Single);
  begin
    if IsZero(P1[2]) and IsZero(P2[2]) then
      Writeln(Format('%f %f   %f %f   %f %f %f',
        [ P1[0], P1[1],
          P2[0], P2[1],
          Col[0], Col[1], Col[2] ]));
  end;

begin
  Col := State.LastNodes.Material.DiffuseColor3Single(MatNum);
  OutputOdcinek(Tri[0], Tri[1]);
  OutputOdcinek(Tri[1], Tri[2]);
  OutputOdcinek(Tri[2], Tri[0]);
end;

var
  Scene: TVRMLFLatScene;
  I: Integer;
  TriangleProcessor: TTriangleProcessor;
begin
  Parameters.CheckHigh(1);
  TriangleProcessor := nil; { no need to actually initialize that }
  Scene := TVRMLFLatScene.Create(LoadAsVRML(Parameters[1], true), true);
  try
    for I := 0 to Scene.ShapeStates.Count - 1 do
      Scene.ShapeStates[I].ShapeNode.Triangulate(
        Scene.ShapeStates[I].State, false,
        @TriangleProcessor.TriangleProc);
  finally Scene.Free end;
end.